


var FICT = (function () {

    'use strict'
    var Defaults = {
        server: "",
        debug: true,
        user: null,
        pass: null,
        lang: "es"
    };

    var timestamp_day = 86400000;//60 * 1000;//

    var FICT = function (opt) {
        this.cfg = extend(opt, Defaults);
        this.pers = {};
        this.store = window.localStorage;
        this.usuario = null;
    };

    FICT.prototype.isLogin = function () {
        return this.store.getItem("evolutel.fict.usuario") ? true : false;
    };

    FICT.prototype.getUsuario = function () {
        if (this.isLogin()) {
            if (!this.usuario) {
                this.usuario = JSON.parse(this.store.getItem("evolutel.fict.user"));
            }
            return this.usuario;
        }
        return null;
    }

    FICT.prototype.login = function (usuario, password, callback) {
        var self = this;
        this._post(
                "http://" + this.cfg.server + "/fict/api/v1/index.php/usuario/login",
                {
                    correo: usuario,
                    password: password
                },
                function (r) {
                    if (r.success) {
                        self.store.setItem("evolutel.fict.usuario", usuario);
                        self.store.setItem("evolutel.fict.password", md5(password));
                        self.usuario = r.data;
                        self.store.setItem("evolutel.fict.user", JSON.stringify(r.data));
                    }
                    try {
                        callback(r);
                    } catch (e) {
                        self.log("ERROR", e);
                    }
                }
        );
    };

    FICT.prototype.logout = function () {
        this.store.removeItem("evolutel.fict.usuario");
        this.store.removeItem("evolutel.fict.password");
        this.store.removeItem("evolutel.fict.user");
    };

    FICT.prototype.registrar = function (data, callback) {
        var self = this;
        this._post(
                "http://" + this.cfg.server + "/fict/api/v1/index.php/usuario/",
                data,
                function (r) {
                    try {
                        callback(r);
                    } catch (e) {
                        self.log("ERROR", e);
                    }
                }
        );
    };

    FICT.prototype.reenviar_codigo = function (correo, callback) {
        var self = this;
        this._post(
                "http://" + this.cfg.server + "/fict/api/v1/index.php/usuario/reenviar_codigo",
                {correo: correo},
                function (r) {
                    try {
                        callback(r);
                    } catch (e) {
                        self.log("ERROR", e);
                    }
                }
        );
    };


    FICT.prototype.activar = function (codigo, callback) {
        var self = this;
        this._post(
                "http://" + this.cfg.server + "/fict/api/v1/index.php/usuario/activar",
                {
                    codigo: codigo
                },
                function (r) {
                    if (r.success) {
                        self.usuario = r.data;
                        self.store.setItem("evolutel.fict.password", self.usuario.password);
                        delete self.usuario.password;
                        self.store.setItem("evolutel.fict.user", JSON.stringify(r.data));
                        self.store.setItem("evolutel.fict.usuario", self.usuario.correo);
                    }
                    try {
                        callback(r);
                    } catch (e) {
                        self.log("ERROR", e);
                    }
                }
        );
    };


    FICT.prototype.registrarPelicula = function (data, callback) {
        if (this.isLogin()) {
            var u = this.getUsuario();
            data.usuario = u.id;
            this._post(
                    "http://" + this.cfg.server + "/fict/api/v1/index.php/pelicula/",
                    data,
                    callback
                    );
        } else {
            callback({success: 0, mensaje: "No has iniciado sesion"});
        }
    };

    FICT.prototype.registrarPonente = function (data, callback) {
        if (this.isLogin()) {
            var u = this.getUsuario();
            data.usuario = u.id;
            this._post(
                    "http://" + this.cfg.server + "/fict/api/v1/index.php/ponente/",
                    data,
                    callback
                    );
        } else {
            callback({success: 0, mensaje: "No has iniciado sesion"});
        }
    };

    FICT.prototype.misPeliculas = function (callback) {
        var user = this.getUsuario();
        var correo = this.store.getItem("evolutel.fict.usuario");
        var pass = this.store.getItem("evolutel.fict.password");
        //(uri, data, table, id_timeout, fn, time)
        _postWebPers.apply(this,
                [
                    "http://" + this.cfg.server + "/fict/api/v1/index.php/usuario/" + user.id + "/peliculas",
                    {
                        correo: correo,
                        pass: pass
                    },
                    "me_peliculas",
                    "me_peliculas",
                    callback,
                    7200000
                ]);
    };

    FICT.prototype.misPonencias = function (callback) {
        var user = this.getUsuario();
        var correo = this.store.getItem("evolutel.fict.usuario");
        var pass = this.store.getItem("evolutel.fict.password");
        //(uri, data, table, id_timeout, fn, time)
        _postWebPers.apply(this,
                [
                    "http://" + this.cfg.server + "/fict/api/v1/index.php/usuario/" + user.id + "/ponencias",
                    {
                        correo: correo,
                        pass: pass
                    },
                    "me_ponencias",
                    "me_ponencias",
                    callback,
                    7200000
                ]);
    };

    FICT.prototype.getPonentes = function (callback) {
        _getWebPers.apply(this,
                [
                    "http://" + this.cfg.server + "/fict/api/v1/index.php/ponente/",
                    "ponentes",
                    "ponentes",
                    callback
                ]);
    };

    FICT.prototype.getPeliculas = function (callback) {
        _getWebPers.apply(this,
                [
                    "http://" + this.cfg.server + "/fict/api/v1/index.php/pelicula/",
                    "pelicula",
                    "pelicula",
                    callback
                ]);
    };

    FICT.prototype.getCategorias = function (callback) {
        _getWebPers.apply(this,
                [
                    "http://" + this.cfg.server + "/fict/api/v1/index.php/pelicula/categorias",
                    "categoria",
                    "categoria",
                    callback
                ]);
    };

    FICT.prototype.getPatrocinadores = function (callback) {
        _getWebPers.apply(this,
                [
                    "http://" + this.cfg.server + "/fict/api/v1/index.php/patrocinador/",
                    "patrocinador",
                    "patrocinador",
                    callback
                ]);
    };

    FICT.prototype.registrarDevice = function (device_id, callback) {
        if (device) {
            var data = {
                platform: device.platform,
                device: device_id
            };
            this._post("http://" + this.cfg.server + "/fict/api/v1/index.php/device", data, function () {
                try {
                    callback();
                } catch (e) {
                    console.error(e);
                }
            });
        }
    };

    FICT.prototype.getNosotros = function (callback) {
        _getWebPers.apply(this,
                [
                    "http://" + this.cfg.server + "/fict/api/v1/index.php/nosotros/",
                    "nosotros",
                    "nosotros",
                    callback
                ]);
    };

    FICT.prototype.getPaises = function (callback) {
        this._get(
                "http://" + this.cfg.server + "/fict/api/v1/index.php/pais/",
                {},
                callback
                );
    };

    FICT.prototype.getEstados = function (pais, callback) {
        this._get(
                "http://" + this.cfg.server + "/fict/api/v1/index.php/pais/" + pais + "/estado",
                {},
                callback
                );
    };

    FICT.prototype.getCiudades = function (pais, estado, callback) {
        this._get(
                "http://" + this.cfg.server + "/fict/api/v1/index.php/pais/" + pais + "/estado/" + estado + "/ciudad",
                {},
                callback
                );
    };

    FICT.prototype.getHistoria = function (callback) {
        _getWebPers.apply(this,
                [
                    "http://" + this.cfg.server + "/fict/api/v1/index.php/historia/",
                    "historia",
                    "historia",
                    callback
                ]);
    };

    FICT.prototype.getNoticas = function (callback) {
        this._get(
                "http://" + this.cfg.server + "/fict/api/v1/index.php/noticias/",
                {},
                callback
                );
    };



    /*
     * 
     * Enviar AYUDA.
     * 
     */

    FICT.prototype.enviarContacto = function (data, callback) {
        this._post(
                "http://" + this.cfg.server + "/fict/api/v1/index.php/ayuda/",
                data,
                callback);
    };



    FICT.prototype.getNotificaciones = function (callback) {
        _getWebPers.apply(this, [
            "http://" + this.cfg.server + "/fict/api/v1/index.php/notificacion/",
            "notificaciones",
            "notificaciones",
            callback,
            1
        ]);
    };


    FICT.prototype.getHoteles = function (callback) {
        _getWebPers.apply(this, [
            "http://" + this.cfg.server + "/fict/api/v1/index.php/hotel/",
            "hoteles",
            "hoteles",
            callback,
        ]);
    };


    var createColums = function (obj) {
        var col = new Array("id");
        for (var i in obj) {
            if (i != "id") {
                col.push(i);
            }
        }
        return col;
    };

    var _getWebPers = function (uri, table, id_timeout, fn, time) {
        if (!time) {
            time = timestamp_day;
        }
        var self = this;
        var dbname = "fict";
        var last_update = this.store.getItem(id_timeout) == null ? "0" : this.store.getItem(id_timeout);
        if (parseInt(last_update) + time < (new Date()).getTime() && navigator.connection.type != "none") {
            self._get(uri, {}, function (res) {
                if (res) {
                    if (res.success) {
                        fn(res.data);
                        var col;
                        if (res.data instanceof Array) {
                            col = createColums(res.data[0]);
                        } else {
                            col = createColums(res.data);
                        }
                        self.pers[table] = new Persistencia(dbname, table, col);
                        self.pers[table].saveData(res.data);
                        self.store.setItem(id_timeout, (new Date()).getTime());
                    }
                } else {
                    getPers(self, fn);
                }
            });
        } else {
            getPers(self, fn);
        }
        function getWeb(self, fn) {
            self._get(uri, {}, function (res) {
                if (res) {
                    if (res.success) {
                        fn(res.data);
                        var col;
                        if (res.data instanceof Array) {
                            col = createColums(res.data[0]);
                        } else {
                            col = createColums(res.data);
                        }
                        self.pers[table] = new Persistencia(dbname, table, col);
                        self.pers[table].saveData(res.data);
                    }
                } else {
                    fn(null);
                }
            });
        }
        function getPers(self, fn) {
            self.pers[table] = new Persistencia(dbname, table);
            self.pers[table].getData(function (r) {
                if (r.length > 0) {
                    if (r.length == 1) {
                        fn(r[0]);
                    } else {
                        fn(r);
                    }
                } else {
                    getWeb(self, fn);
                }
            }, 0, 9999);
        }
    };

    var _postWebPers = function (uri, data, table, id_timeout, fn, time) {
        if (!time) {
            time = timestamp_day;
        }
        var self = this;
        var dbname = "fict";
        var last_update = this.store.getItem(id_timeout) == null ? "0" : this.store.getItem(id_timeout);
        if (parseInt(last_update) + time < (new Date()).getTime() && navigator.connection.type != "none") {
            self._post(uri, data, function (res) {
                if (res) {
                    if (res.success) {
                        fn(res.data);
                        var col = createColums(res.data[0]);
                        self.pers[table] = new Persistencia(dbname, table, col);
                        self.pers[table].saveData(res.data);
                        self.store.setItem(id_timeout, (new Date()).getTime());
                    }
                } else {
                    getPers(self, fn);
                }
            });
        } else {
            getPers(self, fn);
        }
        function getWeb(self, fn) {
            self._post(uri, data, function (res) {
                if (res) {
                    if (res.success) {
                        fn(res.data);
                        var col = createColums(res.data[0]);
                        self.pers[table] = new Persistencia(dbname, table, col);
                        self.pers[table].saveData(res.data);
                    }
                } else {
                    fn(null);
                }
            });
        }
        function getPers(self, fn) {
            self.pers[table] = new Persistencia(dbname, table);
            self.pers[table].getData(function (r) {
                if (r.length > 0) {
                    fn(r);
                } else {
                    getWeb(self, fn);
                }
            }, 0, 9999);
        }
    };

    FICT.prototype._post = function (url, data, callback) {
        var self = this;
        $.ajax({
            url: url,
            method: "POST",
            crossDomain: false,
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + btoa(self.cfg.user + ":" + self.cfg.pass));
                xhr.setRequestHeader("accept", "application/json");
                xhr.setRequestHeader("Accept-Language", self.cfg.lang);
            },
            data: data,
            success: function (r) {
                r = JSON.parse(r);
                if (callback)
                    callback(r);
            },
            error: function () {
                if (callback)
                    callback(null);
            }
        });
    };

    FICT.prototype._get = function (url, data, callback) {
        var self = this;
        $.ajax({
            url: url,
            method: "GET",
//            crossDomain: false,
            beforeSend: function (xhr) {
                console.log("before");
                xhr.setRequestHeader("Authorization", "Basic " + btoa(self.cfg.user + ":" + self.cfg.pass));
                xhr.setRequestHeader("accept", "application/json");
                xhr.setRequestHeader("Accept-Language", self.cfg.lang);
            },
            data: data,
            success: function (r) {
                r = JSON.parse(r);
                if (callback)
                    callback(r);
            },
            error: function () {
                if (callback)
                    callback(null);

            }
        });
    };


    /*<<<<<<<<<<<<<<<<<<<LOGGER>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>*/
    FICT.prototype.log = function (type, msj) {
        if (this.debug)
            switch (type.toUpperCase()) {
                case "ERROR":
                    console.error(new Date(), msj);
                    return
                case "WARNING":
                    console.warn(new Date(), msj);
                    return
                case "INFO":
                    console.info(new Date(), msj);
                    return
                case "DEBUG":
                    console.log(new Date(), msj);
                    return
            }
        console.log(new Date(), msj);
    };
    /*<<<<<<<<<<<<<<<<<<<Utils>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>*/
    var extend = function (toObj, fromObj) {
        toObj = toObj || {};
        Object.keys(fromObj).forEach(function (key) {
            if (!(key in toObj)) {
                toObj[key] = fromObj[key];
            }
        });
        return toObj;
    };
    return FICT;
})();




var Persistencia = (function () {

    var localStore = "evolutel.persistencia.fict.";

    //la columna primera siempre es el id;
    var Persistencia = function (dbname, table, colums) {
        var self = this;
        this.table = table;
        this.colums = colums;
        this.dbname = dbname;
        this.debug = true;
        if (colums) {
            window.localStorage.setItem(localStore + dbname + "." + table, JSON.stringify(colums));
        } else {
            this.colums = JSON.parse(window.localStorage.getItem(localStore + dbname + "." + table));
        }
        if (this.colums) {
            this.db = window.sqlitePlugin.openDatabase({name: dbname + ".db", location: 'default', androidDatabaseImplementation: 2});
            var id = window.localStorage.getItem(localStore + dbname + "." + table + "id");
            if (!id) {
                self.db.executeSql("DROP TABLE IF EXISTS " + table + "");
                var data = self.colums[0] + " text primary key";
                for (var i = 1; i < self.colums.length; i++) {
                    data += "," + self.colums[i] + " text";
                }
                var query = " CREATE TABLE IF NOT EXISTS " + table + " (" + data + "); ";
                self.log("DEBUG", query);
                self.db.executeSql(query, function (res) {
                    //console.log(res);
                }, function (err) {
                    console.error(err);
                });
                window.localStorage.setItem(localStore + dbname + "." + table + "id", dbname);
            }
        }
    };

    Persistencia.prototype.reloadDB = function (fn) {
        if (this.db)
            this.db.close();
        this.db = window.sqlitePlugin.openDatabase({name: this.dbname + ".db"}, fn);
    };


    Persistencia.prototype.saveData = function (json) {
        if (Array.isArray(json)) {
            for (var i in json) {
                var data = json[i];
                insertP(this, data);
            }
        } else {
            insertP(this, json);
        }
    };


    function insertP(self, data) {
        self.db.transaction(function (tx) {
            tx.executeSql("SELECT * from " + self.table + " where  " + self.colums[0] + "='" + data[self.colums[0]] + "'", [], function (tx, res) {
                var query = "";
                if (res.rows.length > 0) {
                    var params = " set ";
                    for (var i = 1; i < self.colums.length; i++) {
                        if (data[self.colums[i]] != undefined) {
                            if (typeof data[self.colums[i]] == "object") {
                                params += self.colums[i] + "='" + JSON.stringify(data[self.colums[i]]) + "' ,";
                            } else
                                params += self.colums[i] + "='" + data[self.colums[i]] + "' ,";
                        }
                    }
                    query = "UPDATE " + self.table + "   " + params.substring(0, params.length - 1) + "  where " + self.colums[0] + "= " + data[self.colums[0]];
                } else {
                    for (var c in self.colums) {
                        if (typeof data[self.colums[c]] == "object") {
                            query += "'" + JSON.stringify(data[self.colums[c]]) + "',";
                        } else {
                            query += "'" + data[self.colums[c]] + "',";
                        }
                    }
                    query = "INSERT INTO " + self.table + " values(" + query.substring(0, query.length - 1) + " )";
                }
                tx.executeSql(query);
            });
        }, function (e) {
            console.log('Transaction error: ' + e.message);
        });
    }

    Persistencia.prototype.delete = function (id, fn) {
        var self = this;
        self.db.transaction(function (tx) {
            tx.executeSql("DELETE FROM " + self.table + " WHERE  " + self.colums[0] + "='" + id + "'; ", [], function (tx, res) {
                fn(res);
            });
        }, function (e) {
            console.log('Transaction error: ' + e.message);
        });
    };


    Persistencia.prototype.deleteAll = function (fn) {
        var self = this;
        self.db.transaction(function (tx) {
            tx.executeSql("DELETE FROM " + self.table + "; ", [], function (tx, res) {
                fn(res);
            });
        }, function (e) {
            console.log('Transaction error: ' + e.message);
        });
    };



    Persistencia.prototype.getMaxId = function (fn) {
        var self = this;
        self.db.transaction(function (tx) {
            tx.executeSql("SELECT max( CAST(" + self.colums[0] + " as integer) ) as total  from " + self.table + ";", [], function (tx, res) {
                if (res.rows.length > 0) {
                    fn(parseInt(res.rows.item(0)["total"]) + 1);
                    return;
                }
                fn(1);
            });
        }, function (e) {
            console.log('Transaction error: ' + e.message);
        });
    };


    Persistencia.prototype.getCount = function (fn) {
        var self = this;
        self.db.transaction(function (tx) {
            tx.executeSql("SELECT COUNT(*) as total  from " + self.table + " group by " + self.colums[0] + ";", [], function (tx, res) {
                if (res.rows.length > 0) {
                    fn(parseInt(res.rows.item(0)["total"]));
                    return;
                }
                fn(1);
            });
        }, function (e) {
            console.log('Transaction error: ' + e.message);
        });
    };

    Persistencia.prototype.getCountWhere = function (where, fn) {
        var self = this;
        self.db.transaction(function (tx) {
            tx.executeSql("SELECT COUNT(*) as total  from " + self.table + " where " + where + " ;", [], function (tx, res) {
                if (res.rows.length > 0) {
                    fn(parseInt(res.rows.item(0)["total"]));
                    return;
                }
                fn(1);
            });
        }, function (e) {
            console.log('Transaction error: ' + e.message);
        });
    };



    Persistencia.prototype.search = function (order_by, where, fn, l1, l2) {
        if (!order_by) {
            order_by = "";
        }
        if (!l1)
            l1 = 0;
        if (!l2)
            l2 = 100;
        var self = this;
        this.db.transaction(function (tx) {
            tx.executeSql("SELECT * from " + self.table + " " + where + " " + order_by + "   limit " + l1 + "," + l2 + " ", [], function (tx, res) {
                var r = new Array();
                for (var i = 0; i < res.rows.length; i++) {
                    r.push(res.rows.item(i));
                }
                fn(r);
            });
        }, function (error) {
            fn([]);
        }, function () {
        });
    };

    Persistencia.prototype.getData = function (fn, l1, l2, order_by) {
        if (!l1)
            l1 = 0;
        if (!l2)
            l2 = 100;
        if (!order_by) {
            order_by = "";
        }
        var self = this;
        if (this.db) {
            this.db.transaction(function (tx) {
                tx.executeSql("SELECT * from " + self.table + " " + order_by + "  limit " + l1 + "," + l2 + "", [], function (tx, res) {
                    var r = new Array();
                    if (l2 === 1) {
                        var temp = res.rows.item(0);
                        for (var i in temp) {
                            var temp2 = temp[i];
                            try {
                                temp2 = JSON.parse(temp[i]);
                                temp[i] = temp2;
                            } catch (e) {
                            }
                        }
                        fn(temp);
                        return;
                    }
                    for (var i = 0; i < res.rows.length; i++) {
                        var temp = res.rows.item(i);
                        for (var key in temp) {
                            var temp2 = temp[key];
                            try {
                                temp2 = JSON.parse(temp[key]);
                                temp[key] = temp2;
                            } catch (e) {
                            }
                        }
                        r.push(temp);
                    }
                    fn(r);
                });
            }, function (error) {
                fn([]);
            }, function () {
            });
        } else {
            console.log("no esta inizializado");
            fn([]);
        }
    };

    /*<<<<<<<<<<<<<<<<<<<LOGGER>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>*/
    Persistencia.prototype.log = function (type, msj) {
        if (this.debug)
            switch (type.toUpperCase()) {
                case "ERROR":
                    console.error(new Date(), msj);
                    return;
                case "WARNING":
                    console.warn(new Date(), msj);
                    return;
                case "INFO":
                    console.info(new Date(), msj);
                    return;
                case "DEBUG":
                    console.log(new Date(), msj);
                    return;
            }
        console.log(new Date(), msj);
    };
    /*<<<<<<<<<<<<<<<<<<<Utils>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>*/
    var extend = function (toObj, fromObj) {
        toObj = toObj || {};
        Object.keys(fromObj).forEach(function (key) {
            if (!(key in toObj)) {
                toObj[key] = fromObj[key];
            }
        });
        return toObj;
    };
    return Persistencia;
})();