/*--------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 *
 *       -       -       -      GLOBAL - NOTIFICATION     -       -       -
 *
 *---------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 */
function initGlobalNoti() {
    if (!localStorage.getItem('push') || localStorage.getItem('push') == 'si') {
        push = PushNotification.init({
            android: {
                senderID: SENDER_ID,
            },
            ios: {
                alert: "true",
                badge: "true",
                sound: "true"
            },
            windows: {}
        });

        PushNotification.hasPermission(function (data) {
            if (data.isEnabled) {
                localStorage.setItem('push', 'si');
            } else {
                localStorage.setItem('push', 'no');
            }
        });

        push.on('registration', function (data) {
            localStorage.setItem('push', 'si');
            if (typeof localStorage.getItem('token') != 'string' || localStorage.getItem('registrer_token') == 'no') {
                aFICT.registrarDevice(data.registrationId, function (r) {
                    if (isEmpty(r)) {
                        localStorage.setItem('registrer_token', 'si');
                    } else {
                        localStorage.setItem('registrer_token', 'no');
                    }
                });
                localStorage.setItem('token', data.registrationId);
            }
        });

        push.on('notification', function (data) {
            mainView.router.loadPage('notificacion.html');
        });

        push.on('error', function (e) {
            console.log(e.message);
        });
    }
}

/*--------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 *
 *       -       -       -      CONTACTO     -       -       -
 *
 *---------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 */
function initContacto() {
    if(aFICT.isLogin()){
        var data = aFICT.getUsuario();
        $('.page[data-page="contacto"] [name="nombre"]').val(data.nombre + ' ' + data.apellido);
        $('.page[data-page="contacto"] [name="email"]').val(data.correo);
    }
    $('#btn_contacto').on('click', function () {
        myApp.showPreloader();
        var formData = myApp.formToJSON('#contacto');
        if (isEmpty(formData.email) || isEmpty(formData.nombre)) {
            myApp.hidePreloader();
            $('#contacto_incorrecto').text("Faltan datos por llenar");
        } else {
            aFICT.enviarContacto(formData, function (r) {
                myApp.hidePreloader();
                if (r.success) {
                    myApp.alert("En breve recibirás una respuesta.", "Listo", function () {
                        myApp.views[0].back();
                    });
                } else {
                    myApp.alert("Ha ocurrido un problema con el servidor, por favor intentelo de nuevo más tarde.", "Error", function () {
                        myApp.views[0].back();
                    });
                }
            });
        }
    });
}

/*--------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 *
 *       -       -       -      LOGIN - REGISTRO     -       -       -
 *
 *---------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 */
function openLogin() {
    traducir($('.login-screen'));
    myApp.closePanel();
    myApp.loginScreen();

    if ($('.login-screen [name="pais"] option').length == 0) {
        aFICT.getPaises(function (result) {
            $.each(result.data, function (i, obj) {
                var option = document.createElement('option');
                option.setAttribute('data-id', obj.id);
                option.text = obj.nombre;
                $('[name="pais"]').append(option);
                if (obj.nombre == 'Mexico') {
                    option.setAttribute('selected', true);
                    $('[name="pais"]').trigger('change');
                }
            });
        });

        $('[name="pais"]').on('change', function () {
            var pais = $(document.getElementsByName('pais')[0].options[document.getElementsByName('pais')[0].selectedIndex]).data('id');
            $('[name="estado"]').text('');
            aFICT.getEstados(pais, function (r) {
                $.each(r.data, function (i, obj) {
                    var option = document.createElement('option');
                    option.setAttribute('data-id', obj.id);
                    option.text = obj.nombre;
                    $('[name="estado"]').append(option);
                });
            });
        });
    }
}

function logout() {
    if (aFICT.isLogin()) {
        aFICT.logout();
        location.href = "index.html";
    }
}

function login() {
    var formData = myApp.formToJSON('#iniciar_usuario');
    if (isEmpty(formData.email) || isEmpty(formData.contrasenia)) {
        $('.incorrecto').text($.i18n.prop('faltan_datos'));
    } else {
        aFICT.login(formData.email, formData.contrasenia, function (r) {
            //console.log(r);
            if (r.success) {
                location.href = "index.html";
            } else {
                $('.incorrecto').text($.i18n.prop('usuario_invalido'));
            }
        });
    }
}

function registroLogin() {
    myApp.showPreloader();
    var formData = myApp.formToJSON('#registrar_usuario');
    if (isEmpty(formData.nombre) || isEmpty(formData.apellido) || isEmpty(formData.correo) ||
            isEmpty(formData.password) || isEmpty(formData.verificar_password)) {
        $('.incorrecto').text($.i18n.prop('faltan_datos'));
        myApp.hidePreloader();
    } else if (formData.password != formData.verificar_password) {
        $('.incorrecto').text($.i18n.prop('password_nocoincide'));
        myApp.hidePreloader();
    } else {
        aFICT.registrar(formData, function (r) {
            myApp.hidePreloader();
            if (r.success) {
                modal_codigo(true)
            } else {
                $('.incorrecto').text(r.data);
            }
        });
    }
}

function modal_codigo(estado) {
    myApp.modal({
        title: $.i18n.prop('codigo'),
        text: '<div class="align-center" style="position:relative;">' +
                '<i class="fa fa-times" onclick="closeModal();" style="position: absolute;top: -50px;right: 0px;"></i>' +
                '<div class="item-input">' +
                '<input type="text" name="codigo" maxlength="5" />' +
                '<br/><br/>' +
                '<p class="mensaje_error_codigo" style="color:red;"></p>' +
                '<p class="buttons-row">' +
                (estado ? ('<button class="button" onclick="reenviar()">' + $.i18n.prop('reenviar_correo') + '</button>') : '') +
                '<button class="button button-fill color-teal" onclick="envia_codigo()">' + $.i18n.prop('listo') + '</button>' +
                '</p>' +
                '</div>' +
                '</div>',
    });
}

function reenviar() {
    //console.log($('#registrar_usuario [name="correo"]').val());
    aFICT.reenviar_codigo($('#registrar_usuario [name="correo"]').val(), function () {});
}
function closeModal() {
    myApp.closeModal();
}
function envia_codigo() {
    aFICT.activar($('[name="codigo"]').val(), function (rq) {
        if (rq.success) {
            myApp.closeModal();
            myApp.alert($.i18n.prop('gracias_registro'), $.i18n.prop('bienvenido'), function () {
                location.href = "index.html";
            });
        } else {
            $('.mensaje_error_codigo').text($.i18n.prop('codigo_invalido'));
        }
    });
}

function upload_image() {
    navigator.camera.getPicture(function (imageData) {
        var image = document.getElementById('foto');
        image.src = "data:image/jpeg;base64," + imageData;
        $('[name="foto"]').val("data:image/jpeg;base64," + imageData);
    }, function () {
        console.log('error');
    }, {quality: 70,
        destinationType: Camera.DestinationType.DATA_URL,
        correctOrientation: true,
        sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
        allowEdit: true,
        encodingType: Camera.EncodingType.JPEG,
        targetWidth: 200,
        targetHeight: 200,
        popoverOptions: CameraPopoverOptions,
        saveToPhotoAlbum: false
    });
}

function take_image() {
    navigator.camera.getPicture(function (imageData) {
        var image = document.getElementById('foto');
        image.src = "data:image/jpeg;base64," + imageData;
        $('[name="foto"]').val("data:image/jpeg;base64," + imageData);
    }, function () {
        console.log('error');
    }, {quality: 70,
        destinationType: Camera.DestinationType.DATA_URL,
        correctOrientation: true,
        cameraDirection: Camera.Direction.FRONT,
        sourceType: Camera.PictureSourceType.CAMERA,
        encodingType: Camera.EncodingType.JPEG,
        targetWidth: 200,
        targetHeight: 200,
    });
}

/*--------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 *
 *       -       -       -      HISTORIA     -       -       -
 *
 *---------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 */
function initHistoria() {
    aFICT.getHistoria(function (r) {
        if (!isEmpty(r)) {
            $('#descripcion_historia').html(r.descripcion);
            $.each(r.integrantes, function (i, obj) {
                var li = document.createElement('li');
                li.setAttribute('class', 'item-content');
                li.innerHTML = '<div class="item-inner">' +
                        '<div class="item-title">' + obj + '</div>' +
                        '</div>';
                $('[data-page="historia"] .list-block').append(li);
            });
        }
    });
}

/*--------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 *
 *       -       -       -      NOTICIAS     -       -       -
 *
 *---------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 */
function initNoticias() {
    var loading = false;
    var nextURL = "ww";

    aFICT.getNoticas(function (r) {
        console.log(r);
        informacion(r.posts);
    });


    $('.infinite-scroll').on('infinite', function () {
        if (loading)
            return;
        loading = true;
        $.ajax({
            url: nextURL,
            method: "GET",
            dataType: "json",
            success: function (request) {
                informacion(request);
            }
        });
    });


    function informacion(items) {
        if (items.data.length == 0) {
            loading = false;
            myApp.detachInfiniteScroll($('.infinite-scroll'));
            $('.infinite-scroll-preloader').remove();
            return;
        } else {
            $.each(items.data, function (i, obj) {
                var li = document.createElement('li');
                li.setAttribute('class', 'card facebook-card');
                li.innerHTML = '<div class="card-header">' +
                        '<a class="facebook-avatar external" href="fb://post/' + obj.id + '" target="_blank" ><img src="img/perfil.png" width="34" height="34"></a>' +
                        '<a class="facebook-name external" href="fb://post/' + obj.id + '" target="_blank" >Festival Internacional de Cine de Tequila - FICT</a>' +
                        '<div class="facebook-date">' + new FormFecha(new Date(obj.created_time), lang).DIAnum_de_MEsnom_a_las_HHMiMiAM() + '</div>' +
                        '</div>' +
                        '<div class="card-content" >' +
                        '<div class="card-content-inner">' +
                        '<p>' + (isEmpty(obj.message) ? '' : obj.message) + '</p>' +
                        '<div class="element"></div>' +
                        '<a class="color-gray external" href="fb://post/' + obj.id + '" target="_blank">Likes: ' + obj.likes.summary.total_count + '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Comments: ' + obj.comments.summary.total_count + '</a>' +
                        '</div>' +
                        '</div>';
                $('.post-facebook').append(li);

                if (isEmpty(obj.picture)) { // SIN ELEMENTOS
                    $(li).find('.element').hide();
                } else if (!isEmpty(obj.source)) { //LINK
                    $($(li).find('.element')[0]).attr('onclick', "openNavegador('" + obj.source + "')");
                    $($(li).find('.element')[0]).html('<img src ="' + obj.full_picture + '" width="100%" /><i class="fa fa-play-circle" aria-hidden="true"></i>');
                } else if ((obj.picture).indexOf('https://external.xx.fbcdn.net/') != -1) { // LINK EXTERNO
                    var div = document.createElement('div');
                    div.setAttribute('class', 'card');
                    div.setAttribute('onclick', 'openNavegador("' + obj.link + '")');
                    div.innerHTML = '<div class="card-content">' +
                            '<div class="row no-gutter">' +
                            '<div class="col-100">' +
                            '<img src="' + obj.picture + '" width="100%"/>' +
                            '</div>' +
                            '<div class="col-100" style="padding:5px;">' +
                            '<div class="title_url"></div>' +
                            '<span class="grey-text lighten-2">' + (getDominio(obj.link)).toUpperCase() + '</span>' +
                            '</div>' +
                            '</div>' +
                            '</div>';
                    $($(li).find('.element')[0]).append(div);
                    getTitleURL(li, obj.link);
                } else { // IMAGEN
                    $($(li).find('.element')[0]).html('<img src ="' + obj.full_picture + '" width="100%" />');
                }

                if ((i + 1) == (items.data).length) {
                    loading = false;
                    nextURL = items.paging.next;
                }
            });
        }
    }
}

function getDominio(url) {
    url = url.split("/");
    return url[2];
}

function getTitleURL(li, url) {
    $.get(url, function (response) {
        var content = document.createElement('div');
        content.innerHTML = response;
        var c = $(content).find('meta[property="og:title"]');
        if(c.length == 0){
            c = $(content).find('title');
            $($(li).find('.title_url')[0]).html($(c[0]).text());
        }else{
            $($(li).find('.title_url')[0]).html(c[0].content);
        }
    });
}
/*--------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 *
 *       -       -       -      PRINCIPAL     -       -       -
 *
 *---------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 */
function initInicio() {
    traducir($('[data-page="index-1"]'));
    traducir($('.view.view-left ul.menu'));
    if (aFICT.isLogin()) {
        $("#menu-logout").show();
        $('#miperfil').show();
        $('#iniciar_registro').hide();

        var data = aFICT.getUsuario();
        $('.menu .menu-nombre').text(data.nombre + ' ' + data.apellido);
        $('.menu .menu-email').text(data.correo);
        $('.menu .menu-user').off('click');
        $($('.menu .menu-user').parent()).attr('href', 'miperfil.html');
        if (!isEmpty(data.foto)) {
            $('.menu .image-user').attr('src', data.foto);
        }
    } else {
        $("#menu-logout").hide();
        $('#miperfil').hide();
        $('#iniciar_registro').show();

        $('.menu .menu-user').on('click', function () {
            openLogin();
        });
        $($('.menu .menu-user').parent()).attr('href', '#');
        $('.menu .menu-nombre').text('');
        $('.menu .menu-email').text('');
        $('.menu .image-user').attr('src', 'img/perfil.png');
    }
}

function initPatrocinadores() {
    $('.contenido-patrocinadores').text('');
    aFICT.getPatrocinadores(function (r) {
        $.each(r, function (i, obj) {
            var li = document.createElement('li');
            li.setAttribute('class', 'item-content item-link');
            li.setAttribute('onclick', 'openNavegador("' + obj.web + '")');
            li.innerHTML = '<div class="item-media"><img src="' + obj.imagen + '" width="50"></div>' +
                    '<div class="item-inner">' +
                    '<div class="item-title-row">' +
                    '<div class="item-title">' + obj.nombre + '</div>' +
                    '</div>' +
                    '</div>';
            $('.contenido-patrocinadores').append(li);
        });
    });
}
/*--------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 *
 *       -       -       -      REGISTRO_PELICULAS     -       -       -
 *
 *---------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 */
function initRegistroPeliculas() {
    phoneMask('[name="telefono"]');
    var data = aFICT.getUsuario();
    $('[data-page="registro_pelicula"] [name="correo"]').val(data.correo);
    $('[data-page="registro_pelicula"] [name="nombre"]').val(data.nombre + ' ' + data.apellido);

    aFICT.getEstados(data.pais.id, function (r) {
        $('[data-page="registro_pelicula"] [name="estado"]').text('');
        $.each(r.data, function (x, elem) {
            var option = document.createElement('option');
            option.setAttribute('data-id', elem.id);
            option.setAttribute('data-an', data.estado.id);
            option.text = elem.nombre;
            $('[data-page="registro_pelicula"] [name="estado"]').append(option);
            if (elem.id == data.estado.id) {
                option.setAttribute('selected', 'true');
                $('[data-page="registro_pelicula"] [name="estado"]').trigger('change');
            }
        });
    });

    $('[data-page="registro_pelicula"] [name="estado"]').on('change', function () {
        var estado = $(document.getElementsByName('estado')[0].options[document.getElementsByName('estado')[0].selectedIndex])
        $('[data-page="registro_pelicula"] [name="ciudad"]').text('');
        aFICT.getCiudades(estado.data('an'), estado.data('id'), function (r) {
            $.each(r.data, function (i, obj) {
                var option = document.createElement('option');
                option.text = obj.nombre;
                $('[data-page="registro_pelicula"] [name="ciudad"]').append(option);
            });
        });
    });

}

function submitPelicula() {
    console.log('click peliculas');

    myApp.showPreloader();
    var formData = myApp.formToJSON('#form_pelicula');
    if (isEmpty(formData.nombre) || isEmpty(formData.telefono) || isEmpty(formData.direccion) || isEmpty(formData.correo)
            || isEmpty(formData.estado) || isEmpty(formData.ciudad) || isEmpty(formData.escuela) || isEmpty(formData.categoria)
            || isEmpty(formData.nombre_proyecto)) {
        myApp.hidePreloader();
        $('#mensaje_error').text($.i18n.prop('faltan_datos'));
    } else {
        aFICT.registrarPelicula(formData, function (r) {
            myApp.hidePreloader();
            if (isEmpty(r) || !r.success) {
                $('#mensaje_error').text($.i18n.prop('error_servidor'));
            } else {
                myApp.alert($.i18n.prop('gracias'), $.i18n.prop('exitoso_registro'), function () {
                    myApp.views[0].back();
                });
            }
        });
    }
}
/*--------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 *
 *       -       -       -      REGISTRO_PONENCIA     -       -       -
 *
 *---------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 */
function initRegistroPonencia() {
    phoneMask('[name="telefono"]');
    var data = aFICT.getUsuario();
    $('[data-page="registro_ponente"] [name="correo"]').val(data.correo);
    $('[data-page="registro_ponente"] [name="nombre"]').val(data.nombre + ' ' + data.apellido);

    aFICT.getEstados(data.pais.id, function (r) {
        $('[data-page="registro_ponente"] [name="estado"]').text('');
        $.each(r.data, function (x, elem) {
            var option = document.createElement('option');
            option.setAttribute('data-id', elem.id);
            option.setAttribute('data-an', data.estado.id);
            option.text = elem.nombre;
            $('[data-page="registro_ponente"] [name="estado"]').append(option);
            if (elem.id == data.estado.id) {
                option.setAttribute('selected', 'true');
                $('[data-page="registro_ponente"] [name="estado"]').trigger('change');
            }
        });
    });

    $('[data-page="registro_ponente"] [name="estado"]').on('change', function () {
        var estado = $(document.getElementsByName('estado')[0].options[document.getElementsByName('estado')[0].selectedIndex])
        $('[data-page="registro_ponente"] [name="ciudad"]').text('');
        aFICT.getCiudades(estado.data('an'), estado.data('id'), function (r) {
            $.each(r.data, function (i, obj) {
                var option = document.createElement('option');
                option.text = obj.nombre;
                $('[data-page="registro_ponente"] [name="ciudad"]').append(option);
            });
        });
    });
}

function submitPonencia() {
    console.log('click ponentes');

    myApp.showPreloader();
    var formData = myApp.formToJSON('#form_ponencia');

    if (isEmpty(formData.nombre) || isEmpty(formData.telefono) || isEmpty(formData.correo) || isEmpty(formData.escuela) || isEmpty(formData.direccion) || isEmpty(formData.nombre_ponencia)) {
        $('#mensaje_error').text($.i18n.prop('faltan_datos'));
        myApp.hidePreloader();
    } else {
        aFICT.registrarPonente(formData, function (r) {
            myApp.hidePreloader();
            if (isEmpty(r) || !r.success) {
                $('#mensaje_error').text($.i18n.prop('error_servidor'));
            } else {
                myApp.alert($.i18n.prop('gracias'), $.i18n.prop('exitoso_registro'), function () {
                    myApp.views[0].back();
                });
            }
        });
    }
}
/*--------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 *
 *       -       -       -      MI_PERFIL     -       -       -
 *
 *---------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 */
function initMiperfil() {
    if (aFICT.isLogin()) {
        var data = aFICT.getUsuario();
        $('.miperfil-portada .name-user').text(data.nombre + ' ' + data.apellido);
        if (!isEmpty(data.foto)) {
            $('.miperfil-portada .image-user').attr('src', data.foto);
        }

        aFICT.misPeliculas(function (r) {
            if (isEmpty(r)) {
                $('.miperfil-portada .pelicula-user').html('<i class="fa fa-film" aria-hidden="true"></i>&nbsp; 0');
            } else {
                $('.miperfil-portada .pelicula-user').html('<i class="fa fa-film" aria-hidden="true"></i>&nbsp;' + r.length);
                $('.miperfil-peliculas').text('');
                $.each(r, function (i, obj) {
                    var li = document.createElement('li');
                    li.setAttribute('class', 'item-content');
                    li.innerHTML = '<div class="item-inner">' +
                            '<div class="item-title">' + obj.nombre_proyecto + '/' + obj.categoria + '</div>' +
                            '<div class="item-after">' +
                            '<span class="badge ' + ((obj.status == 0) ? 'grey darken-1' : ((obj.status == 1) ? 'patone7721C-100' : 'red darken-2')) + '">' + ((obj.status == 0) ? $.i18n.prop('pendiente_aprobacion') : ((obj.status == 1) ? $.i18n.prop('aprobado') : $.i18n.prop('rechazado'))) + '</span>' +
                            '</div>' +
                            '</div>';
                    $('.miperfil-peliculas').append(li);
                });
            }
        });

        aFICT.misPonencias(function (r) {
            //console.log(r);
            if (isEmpty(r)) {
                $('.miperfil-portada .ponencia-user').html('<i class="fa fa-male" aria-hidden="true"></i>&nbsp; 0');
            } else {
                $('.miperfil-portada .ponencia-user').html('<i class="fa fa-male" aria-hidden="true"></i>&nbsp;' + r.length);
                $('.miperfil-ponencia').text('');
                $.each(r, function (i, obj) {
                    var li = document.createElement('li');
                    li.setAttribute('class', 'item-content');
                    li.innerHTML = '<div class="item-inner">' +
                            '<div class="item-title">' + obj.nombre_ponencia + '</div>' +
                            '<div class="item-after">' +
                            '<span class="badge ' + ((obj.status == 0) ? 'grey darken-1' : ((obj.status == 1) ? 'patone7721C-100' : 'red darken-2')) + '">' + ((obj.status == 0) ? $.i18n.prop('pendiente_aprobacion') : ((obj.status == 1) ? $.i18n.prop('aprobado') : $.i18n.prop('rechazado'))) + '</span>' +
                            '</div>' +
                            '</div>';
                    $('.miperfil-ponencia').append(li);
                });
            }
        });

    } else {
        myApp.views[0].back();
    }
}

/*--------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 *
 *       -       -       -     NOTIFICACIONES     -       -       -
 *
 *---------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 */
function initTablero() {
    aFICT.getNotificaciones(function (r) {
        $('.contenido-tablero').text('');
        if (isEmpty(r)) {
            var li = document.createElement('li');
            li.innerHTML = '<div class="item-content">' +
                    '<div class="item-inner">' +
                    '<div class="item-title-row">' +
                    '<div class="item-title">' + $.i18n.prop('no_hay_notificaciones') + '</div>' +
                    '</div>' +
                    '</div>' +
                    '</div>';
            $('.contenido-tablero').append(li);
        } else {
            $.each(r, function (i, obj) {
                var li = document.createElement('li');
                li.innerHTML = '<a href="#" class="item-content">' +
                        '<div class="item-inner">' +
                        '<div class="item-title-row">' +
                        '<div class="item-title" style="max-height: none; display: flex;">' + obj.titulo + '</div>' +
                        '</div>' +
                        '<div class="item-text black-text" style="max-height: none; display: flex;">' + obj.texto + '</div>' +
                        '<div class="item-text">' + new FormFecha(obj.fecha_notificacion, lang).DIAnum_de_MEsnom_a_las_HHMiMiAM() + '</div>' +
                        '</div>' +
                        '</a>';
                $('.contenido-tablero').append(li);
            });
        }
    });
}

/*--------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 *
 *       -       -       -      NOSOTROS     -       -       -
 *
 *---------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 */
function initNosotros() {
    aFICT.getNosotros(function (r) {
        $('.contenido-nosotros').text();
        $.each(r, function (i, obj) {
            var li = document.createElement('li');
            li.setAttribute('class', 'accordion-item');
            li.innerHTML = '<a href="#" class="item-content item-link">' +
                    '<div class="item-media">' +
                    '<img src="' + obj.foto + '" width="80" />' +
                    '</div>' +
                    '<div class="item-inner">' +
                    '<div class="item-title-row">' +
                    '<div class="item-title">' + obj.nombre + '</div>' +
                    '<div class="item-after">' + obj.puesto + '</div>' +
                    '</div>' +
                    '</div>' +
                    '</a>' +
                    '<div class="accordion-item-content">' +
                    '<div class="content-block">' +
                    '<p class="align-justify">' + obj.descripcion + '</p>' +
                    ' </div>' +
                    '</div>';
            $('.contenido-nosotros').append(li);
        });
    });
}

/*--------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 *
 *       -       -       -      HOSPEDARME     -       -       -
 *
 *---------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 */
function initHospedarme(){
    aFICT.getHoteles(function (r) {
        $('.contenido-hospedarme').text();
        $.each(r, function (i, obj) {
            var li = document.createElement('li');
            li.setAttribute('class', 'accordion-item');
            li.innerHTML = '<a href="#" class="item-content item-link">' +
                    '<div class="item-media">' +
                    '<img src="' + obj.imagen + '" width="80" />' +
                    '</div>' +
                    '<div class="item-inner">' +
                    '<div class="item-title-row">' +
                    '<div class="item-title">' + obj.nombre + '</div>' +
                    '</div>' +
                    '</div>' +
                    '</a>' +
                    '<div class="accordion-item-content">' +
                    '<div class="content-block">' +
                    '<img class="img-responsive" src="' + obj.url + '"/>' +
                    ' </div>' +
                    '</div>';
            $('.contenido-hospedarme').append(li);
        });
    });
}
/*--------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 *
 *       -       -       -      FUNCIONES GLOBALES     -       -       -
 *
 *---------------------------------------------------------------------------------------
 *---------------------------------------------------------------------------------------
 */
function openNavegador(url) {
    var ref = cordova.InAppBrowser.open(url, '_blank', 'location=yes');
}

function llamadas(numero) {
    window.PhoneCaller.call(numero, function () {
    }, function (error) {
        alert(error);
    });
}

function traducir(obj) {
    $(obj.find('[data-i18n]')).each(function (i, obj) {
        if ($(obj).is('input')) {
            $(obj).attr('placeholder', $.i18n.prop($(obj).data('i18n')));
        } else {
            $(obj).html($.i18n.prop($(obj).data('i18n')));
        }
    });
}

function isEmpty(str) {
    if (str == "" || str == null || str == undefined || str == "null") {
        return true;
    }
    return false;
}

var FormFecha = function (fecha, idioma) {
    var _fecha = (typeof fecha == 'string') ? new Date(fecha.replace(/-/g, "/")) : fecha;
    var _lang = idioma;
    var _days = new Array("Lunes", "Martes", "Miercoles", "Jueves", "Viernes", "Sabado", "Domingo");
    var _days_short = new Array("Lun", "Mar", "Mie", "Jue", "Vie", "Sab", "Dom");
    var _months = new Array("Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio", "Agosto", "Septiembre", "Octubre", "Noviembre", "Diciembre");
    var _months_short = new Array("Ene", "Feb", "Mar", "Abri", "May", "Jun", "Jul", "Ago", "Sep", "Oct", "Nov", "Dic");
    var _days_en = new Array("Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday");
    var _days_short_en = new Array("Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun");
    var _months_en = new Array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
    var _months_short_en = new Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sept", "Oct", "Nov", "Dec");

    this.ANIO_MESnum = function () {
        return _fecha.getFullYear() + "-" + ('0' + (_fecha.getMonth() + 1)).slice(-2);
    };
    this.MESletra_ANIO = function () {
        switch (_lang) {
            case "en":
                return _months_en[_fecha.getMonth()] + " " + _fecha.getFullYear();
            case "es":
            default:
                return _months[_fecha.getMonth()] + " " + _fecha.getFullYear();
        }
    };
    this.DIAletra = function () {
        switch (_lang) {
            case "en":
                return "" + _days_en[_fecha.getDay()];
            case "es":
            default:
                return "" + _days[_fecha.getDay()];
        }
    };
    this.DIAletra_SHORT = function () {
        switch (_lang) {
            case "en":
                return _days_short_en[_fecha.getDay()];
            case "es":
            default:
                return _days_short[_fecha.getDay()];
        }
    };
    this.DIAnum = function () {
        return _fecha.getDate();
    };
    this.DIAnum_de_MEsnom_a_las_HHMiMiAM = function () {
        var hora = (_fecha.getHours() >= 13) ? (_fecha.getHours() - 12) : _fecha.getHours();
        var minuto = ('0' + _fecha.getMinutes()).slice(-2);
        switch (_lang) {
            case "en":
                return _months_en[_fecha.getMonth()] + " " + _fecha.getDate() + " at " + hora + ':' + minuto + ((_fecha.getHours() >= 12) ? 'PM' : 'AM');
            case "es":
            default:
                return _fecha.getDate() + " de " + _months[_fecha.getMonth()] + " a las " + hora + ':' + minuto + ((_fecha.getHours() >= 12) ? 'PM' : 'AM');
        }
    };
    this.HHMiMiAM = function () {
        var hora = (_fecha.getHours() >= 13) ? (_fecha.getHours() - 12) : _fecha.getHours();
        var minuto = ('0' + _fecha.getMinutes()).slice(-2);
        return hora + ':' + minuto + ((_fecha.getHours() >= 12) ? 'PM' : 'AM');
    };
};

function phoneMask(elemento) {
    $(elemento).keydown(function (e) {
        var key = e.charCode || e.keyCode || 0;
        $phone = $(this);
        if (key !== 8 && key !== 9) {
            if ($phone.val().length === 4) {
                $phone.val($phone.val() + ')');
            }
            if ($phone.val().length === 5) {
                $phone.val($phone.val() + ' ');
            }
            if ($phone.val().length === 9) {
                $phone.val($phone.val() + '-');
            }
        }

        return (key == 8 ||
                key == 9 ||
                key == 46 ||
                (key >= 48 && key <= 57) ||
                (key >= 96 && key <= 105));
    }).on('focus click', function () {
        $phone = $(this);

        if ($phone.val().length === 0) {
            $phone.val('(');
        } else {
            var val = $phone.val();
            $phone.val('').val(val);
        }
    }).blur(function () {
        $phone = $(this);

        if ($phone.val() === '(') {
            $phone.val('');
        }
    });
}