var myApp = new Framework7({
    material: true,
    notificationCloseOnClick: true,
    swipePanel: 'left',
    cache: true
});

var mainView = myApp.addView('.view-main', {});
var leftView = myApp.addView('.view-left', {});
jQuery.i18n.properties({
    name: 'Messages',
    path: 'locales/',
    mode: 'both',
    language: lang,
    callback: function () {
        initInicio();
    }
});

document.addEventListener("backbutton", functionAtras, false);
document.addEventListener("menubutton", functionMenu, false);
document.addEventListener('deviceready', onDeviceReady, false);
function onDeviceReady() {
    try {
        initGlobalNoti();
    } catch (e) {
        console.log(e);
    }
}

function functionAtras() {
    if ($('body').hasClass('with-panel-left-cover')) {
        myApp.closePanel();
    } else if($('.login-screen.modal-in').length > 0){
        myApp.views[0].back();
        myApp.closeModal(close-login-screen);
    } else if (myApp.views[0].activePage.name != "index-1") {
        myApp.views[0].back();
    } else {
        navigator.app.exitApp();
    }
}

function functionMenu() {
    if ($('body').hasClass('with-panel-left-cover')) {
        myApp.closePanel();
    } else {
        myApp.openPanel('left');
    }
}

/*------------------------------------------------------------------------------
 * 
 * 
 *          -       -        -       PRINCIPAL      -       -       -
 * 
 * -----------------------------------------------------------------------------
 */

myApp.onPageInit('index-1', function (page) {
    try {
        initInicio();
    } catch (e) {
        console.log(e);
    }
});




myApp.onPageBeforeInit('registro_pelicula', function (page) {
    traducir($('.page[data-page="registro_pelicula"]'));
});
myApp.onPageInit('registro_pelicula', function (page) {
    try {
        if (aFICT.isLogin()) {
            initRegistroPeliculas();
        } else {
            openLogin();
        }
    } catch (e) {
        console.log(e);
    }
});





myApp.onPageBeforeInit('registro_ponente', function (page) {
    traducir($('.page[data-page="registro_ponente"]'));
});
myApp.onPageInit('registro_ponente', function (page) {
    try {
        if (aFICT.isLogin()) {
            initRegistroPonencia();
        } else {
            openLogin();
        }
    } catch (e) {
        console.log(e);
    }
});





myApp.onPageBeforeInit('historia', function (page) {
    traducir($('.page[data-page="historia"]'));
});
myApp.onPageInit('historia', function (page) {
    try {
        initHistoria();
    } catch (e) {
        console.log(e);
    }
});




myApp.onPageBeforeInit('noticias', function (page) {
    traducir($('.page[data-page="noticias"]'));
});
myApp.onPageInit('noticias', function (page) {
    try {
        initNoticias();
    } catch (e) {
        console.log(e);
    }
});




myApp.onPageBeforeInit('miperfil', function (page) {
    traducir($('.page[data-page="miperfil"]'));
});
myApp.onPageInit('miperfil', function (page) {
    try {
        initMiperfil();
    } catch (e) {
        console.log(e);
    }
});





myApp.onPageBeforeInit('patrocinadores', function (page) {
    traducir($('.page[data-page="patrocinadores"]'));
});
myApp.onPageInit('patrocinadores', function (page) {
    try {
        initPatrocinadores();
    } catch (e) {
        console.log(e);
    }
});




myApp.onPageBeforeInit('nosotros', function (page) {
    traducir($('.page[data-page="nosotros"]'));
});
myApp.onPageInit('nosotros', function (page) {
    try {
        initNosotros();
    } catch (e) {
        console.log(e);
    }
});



myApp.onPageBeforeInit('hospedarme', function (page) {
    traducir($('.page[data-page="hospedarme"]'));
});
myApp.onPageInit('hospedarme', function (page) {
    try {
        initHospedarme();
    } catch (e) {
        console.log(e);
    }
});



myApp.onPageBeforeInit('contacto', function (page) {
    traducir($('.page[data-page="contacto"]'));
});
myApp.onPageInit('contacto', function (page) {
    try {
        initContacto();
    } catch (e) {
        console.log(e);
    }
});


myApp.onPageBeforeInit('notificacion', function (page) {
    traducir($('.page[data-page="notificacion"]'));
});
myApp.onPageInit('notificacion', function (page) {
    try {
        initTablero();
    } catch (e) {
        console.log(e);
    }
});